#!/usr/local/bin/perl

$CGIPATH = '.';

#
# article.cgi -- post article.
# Copyright (C) 1996-1998 nir@mvg.biglobe.ne.jp
#
# This file is part of WebForum.
# WebForum is free script; you can redistribute it and/or modify it
# for any purpose.
#
# @(#)$Id: article.cgi,v 1.14.1.2 1998/09/05 03:11:49 nir Exp $
#

require "$CGIPATH/forum.pl";
require "$CGIPATH/jcode.pl";

@ids = ('name', 'email', 'subject', 'url', 'text');

%http_args = &http'http_args;
$post	= $http_args{'post'};
$edit	= $http_args{'edit'};
$room	= $http_args{'room'};
$ref	= $http_args{'ref'};
$secure	= $http_args{'secure'};
$plain	= $http_args{'plain'};
%http_cookie = &http'http_cookie;
%gui	= &forum'get_gui($http_cookie{'gui'});
$noframes = (($gui{'frame'} eq 'no') || ($http_args{'frame'} eq 'no'));
if ($noframes) {
	$get_option = '&frame=no';
	$post_option = qq(\n<INPUT TYPE="hidden" NAME="frame" VALUE="no">);
}

$title = &forum'get_title($room);
&WarningMsg('Bad Forum') if ($title eq '');

foreach $key (@ids) {
	$ids{$key} = $http_args{$key};
}
if ($post) {
	&http'strip_args(*ids);
	&check_items;
	&kanji_convert;
	&save_items;
	($text, $head, $body) = &div_text($ids{'text'});
	&quote_items;
	&make_article;
	if ($edit) {
		&preview_article;
	} else {
		&post_article;
	}
} else {
	$is_plain = 1;
	unless ($edit) {
		$ids{'name'} = $http_cookie{'name'};
		$ids{'email'} = $http_cookie{'email'};
		$ids{'url'} = $http_cookie{'url'};
		$ids{'url'} = 'http://' if ($ids{'url'} eq '');
		($ids{'subject'}, $ids{'text'}) = &follow_article;
	}
	$header = ($ref) ? "Lԍ${ref}ւ̃tH[" : 'VKL';
	&http'strip_args(*ids);
	&kanji_convert;
	&quote_items;
	&make_form;
}
exit(0);

sub check_items {
	&WarningMsg('Missing Name') if ($ids{'name'} eq '');
	&WarningMsg('Bad Email Address') unless (&email_check($ids{'email'}));
	&WarningMsg('Missing Subject') if ($ids{'subject'} eq '');
	&WarningMsg('Missing Text') if ($ids{'text'} eq '');
}

sub save_items {
	$name = $ids{'name'};
	$email = $ids{'email'};
	$url = $ids{'url'};
}

sub quote_items {
	local($key);

	foreach $key (@ids) {
		$ids{$key} =~ tr/\x00-\x1F\x7F/ /s if ($key ne 'text');
		$ids{$key} = &http'http_quote($ids{$key});
	}
}

sub kanji_convert {
	local($opt) = ($forum'htoz) ? 'z' : '';

	$ids{'name'} = &jcode'to('sjis', $ids{'name'}, '', $opt);
	$ids{'subject'} = &jcode'to('sjis', $ids{'subject'}, '', $opt);
	$ids{'text'} = &jcode'to('sjis', $ids{'text'}, '', $opt);
}

sub div_text {
	local($head, $body);
	local($_) = @_;

	$_ = &http'http_quote($_) if ($plain eq 'on');
	$_ = &forum'ssi_commentout($_);
	if (m#^<HEAD>#i) {
		$_ = $';
		if (m#</HEAD>#i) {
			$head = $`;
			$_ = &http'strip($');
		}
	}
	if ((m#^<BODY>#i) || (m#^<BODY\s[^>]*>#i)) {
		$body = $&;
		$_ = &http'strip($');
	}
	return($_, $head, $body);
}

sub follow_article {
	local($input, $line, $in_mes);
	local($mon, $day, $from, $subject, $text);

	($ref, $mon, $day, $from, $subject) = &get_contents($room, $ref);
	return('', '') unless ($ref);
	$subject = &http'strip($subject);
	$subject =~ s/^re:\s*//i;
	$subject = 'Re: ' . &http'http_unquote($subject);
	open(MES, "$FORUMPATH/$room/$ref.html") || &ErrorMsg('missing', "$room/$ref.html");
	while (<MES>) { $input .= $_; }
	close(MES);
	&forum'line_in_convert(*input);
	$text = sprintf("%d%dɁA%s͏܂B\n\n", $mon, $day, $from);
	$in_mes = 0;
	$is_plain = &unquote_line(*text);
	foreach $line (split(/\n/, $input)) {
		$in_mes = 1, next if ($line =~ /^<!-- begin text -->$/);
		next unless ($in_mes);
		last if ($line =~ /^<!-- end text -->$/);
		$is_plain = 0 unless (&unquote_line(*line));
		$text .= "$line\n";
	}
	return($subject, $text);
}

sub unquote_line {
	local($unquote);
	local(*line) = @_;

	$unquote = &http'http_unquote($line);
	$line = $unquote if ($plain eq 'on');
	return($line eq $unquote);
}

sub make_form {
	local($unquote_ref, $output);
	local($help) = &forum'help('post');
	local($cookies_help) = &forum'help('cookies');
	local($escape_help) = &forum'help('escape');
	local($secure_checked) = ($secure eq 'on') ? 'CHECKED' : '';
	local($plain_checked) = ($plain eq 'on') ? 'CHECKED' : '';

	$unquote_ref = <<"EOL" unless ($is_plain);
pLHTMLGXP[v
<A HREF="$CGIROOT/article.$CGI?room=$room&ref=$ref&plain=on$get_option">̂܂܈p</A>
邱Ƃo܂B
$escape_help
EOL
	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE (Post Article)</TITLE></HEAD>
$BODY
<H1>${title}ւ̓e
$help</H1>
${header}𓊍e܂B<BR>
$unquote_ref<P>
<FORM ACTION="$CGIROOT/article.$CGI" METHOD="POST">$post_option
<INPUT TYPE="hidden" NAME="post" VALUE="post">
<INPUT TYPE="hidden" NAME="room" VALUE="$room">
<INPUT TYPE="hidden" NAME="ref" VALUE="$ref">
OiylCŌ\\łKvłj<BR>
<INPUT NAME="name" SIZE="30" VALUE="$ids{'name'}">
i<INPUT TYPE="checkbox" NAME="secure" $secure_checked VALUE="on">uEUɌloȂj
$cookies_help<BR>
dqCAhXiKvłj<BR>
<INPUT NAME="email" SIZE="60" VALUE="$ids{'email'}"><BR>
薼iKvłj<BR>
<INPUT NAME="subject" SIZE="60" VALUE="$ids{'subject'}"><BR>
Home Page ̓N] URL Lڂĉ<BR>
<INPUT NAME="url" SIZE="60" VALUE="$ids{'url'}"><BR>
cɍڂeȉւ
i<INPUT TYPE="checkbox" NAME="plain" $plain_checked VALUE="on">HTML߂ɂ̂܂ܕ\\j
$escape_help<BR>
<TEXTAREA NAME="text" ROWS="15" COLS="80">$ids{'text'}</TEXTAREA>
<P>
<INPUT TYPE="submit" VALUE="e">
<INPUT TYPE="submit" NAME="edit" VALUE="v[">
<INPUT TYPE="reset" VALUE="Zbg">
</FORM>
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub open_contents {
	local($room) = @_;

	open(CONTENTS, "+<$FORUMPATH/$room/contents") || &ErrorMsg('write', "$room/contents");
	&forum'filelock(CONTENTS, 1) || &ErrorMsg('lock', "$room/contents");
	$_ = <CONTENTS>;
	chop;
	($min_mes, $mes) = /^(\d{5}) (\d{5}) \S{3,}$/;
	&ErrorMsg('format', "$room/contents") unless (($min_mes) && ($mes) && ($min_mes <= $mes));
}

sub close_contents {
	&forum'filelock(CONTENTS, 0);
	close(CONTENTS);
}

sub make_article {
	local($sec, $min, $hour, $mday, $mon, $year);

	$link = $ids{'name'};
	$link = qq(<A HREF="$ids{'url'}" TARGET="_top">$link</A>) if (&url_check($ids{'url'}));
	($sec, $min, $hour, $mday, $mon, $year) = &http'local_time(time);
	$date = sprintf("%4d/%02d/%02d %02d:%02d:%02d", 1900 + $year, $mon + 1, $mday, $hour, $min, $sec);
	$reference = ($ref) ? qq{Reference: <A HREF="$FORUMROOT/$room/$ref.html">$room/$ref</A><BR>\n} : '';

	if ($forum'room_forward{$room} eq '') {
		$post_room = $room;
		&open_contents($post_room);
		&WarningMsg('Read Only') if (($forum'room_max{$post_room} > 0) && ($mes >= $forum'room_max{$post_room}));
	} elsif ($forum'room_max{$room} > 0) {
		$post_room = $room;
		&open_contents($post_room);
		if ($mes >= $forum'room_max{$post_room}) {
			&close_contents;
			$post_room = $forum'room_forward{$room};
			&open_contents($post_room);
		}
	} else {
		$post_room = $forum'room_forward{$room};
		&open_contents($post_room);
		if (($forum'room_max{$post_room} > 0) && ($mes >= $forum'room_max{$post_room})) {
			&close_contents;
			$post_room = $room;
			&open_contents($post_room);
		}
	}
	$max_mes = sprintf("%05d", $mes + 1);

	$title = &forum'get_title($post_room);
	$head = "<TITLE>$title ($mes)</TITLE>" if ($head eq '');
	$body = $BODY if ($body eq '');

	$article = <<"EOL";
<A HREF="$CGIROOT/article.$CGI?room=$post_room">
${NEWICON}VKLe</A>
<A HREF="$CGIROOT/article.$CGI?room=$post_room&ref=$mes">
${FOLLOWICON}tH[Le</A>
<A HREF="$CGIROOT/cancel.$CGI?room=$post_room&mes=$mes">
${CANCELICON}L̃LZ</A>
<HR>
From: $link
&lt;<A HREF="mailto:$ids{'email'}">$ids{'email'}</A>&gt;<BR>
Subject: $ids{'subject'}<BR>
Date: $date<BR>
$reference<PRE>
<!-- begin text -->
$text
<!-- end text -->
</PRE>
EOL
}

sub preview_article {
	local($output);
	local($base) = sprintf("%s%s/%s/", &http'server_url, $FORUMROOT, $post_room);

	&close_contents;
	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD>$head
<BASE HREF="$base">
</HEAD>
$body
$article<P>
<FORM ACTION="$CGIROOT/article.$CGI" METHOD="POST">$post_option
<INPUT TYPE="hidden" NAME="room" VALUE="$room">
<INPUT TYPE="hidden" NAME="ref" VALUE="$ref">
<INPUT TYPE="hidden" NAME="plain" VALUE="$plain">
<INPUT TYPE="hidden" NAME="secure" VALUE="$secure">
<INPUT TYPE="hidden" NAME="name" VALUE="$ids{'name'}">
<INPUT TYPE="hidden" NAME="email" VALUE="$ids{'email'}">
<INPUT TYPE="hidden" NAME="subject" VALUE="$ids{'subject'}">
<INPUT TYPE="hidden" NAME="url" VALUE="$ids{'url'}">
<INPUT TYPE="hidden" NAME="text" VALUE="$ids{'text'}">
<HR>
<INPUT TYPE="submit" NAME="post" VALUE="̂܂ܓe">
<INPUT TYPE="submit" NAME="edit" VALUE="ĕҏW">
</FORM>
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub post_article {
	local($cookie, $output);
	local($post_body) = $BODY;
	local($init) = ($secure eq 'on');
	local($cookies_help) = &forum'help('cookies');
	local($secure_checked) = ($secure eq 'on') ? 'CHECKED' : '';
	local($contents_target) = ($noframes) ? '' : ' TARGET="contents"';
	local($passwd) = $http_cookie{'passwd'};
	$passwd = &forum'get_passwd if ($passwd eq '');
	local($cryptpass) = &forum'get_cryptpass($passwd);
	$output = "<HTML>\n<HEAD>$head</HEAD>\n$body\n$article</BODY>\n</HTML>\n";
	&forum'line_out_convert(*output);
	open(HTML, ">$FORUMPATH/$post_room/$mes.html") || &ErrorMsg('write', "$post_room/$mes.html");
	binmode(HTML);
	print(HTML $output);
	close(HTML);
	chmod(0444, "$FORUMPATH/$post_room/$mes.html");
	seek(CONTENTS, 0, 0);
	printf(CONTENTS "%05d %05d", $min_mes, $max_mes);
	seek(CONTENTS, 0, 2);
	printf(CONTENTS "%05d %05d %s %s <%s> %s\n",
		$mes, ($post_room eq $room) ? $ref : 0,
		$cryptpass, $date, $ids{'name'}, $ids{'subject'});
	open(NEW, ">$FORUMPATH/new_arrival") && close(NEW);
	&close_contents;

	$post_body =~ s#>$#\nonLoad="window.open('$CGIROOT/contents.$CGI?room=$post_room','contents')"># unless($noframes);
	$cookie = &forum'set_cookie_line('name', $name, $init);
	$cookie .= &forum'set_cookie_line('email', $email, $init);
	$cookie .= &forum'set_cookie_line('url', $url, $init);

	$output = "Content-Type: text/html\n$cookie\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>e ($title/$mes)</TITLE></HEAD>
$post_body
<H1>e</H1>
<P>${link}́u<A HREF="$CGIROOT/contents.$CGI?room=$post_room"$contents_target>${title}</A>vւ̓e͐Ɋ܂B
<P>eu<A HREF="$FORUMROOT/$post_room/$mes.html">$ids{'subject'}</A>v
ɓǂނƂo܂B
<P>
A̋LLZȂƂ́A
L̃R[hgăLZĉB
LZR[h͎̍DȂ (Wȓ) ɕύX邱Ƃł܂B
<P>
<FORM ACTION="$CGIROOT/cancel.$CGI" METHOD="POST">$post_option
<INPUT TYPE="hidden" NAME="room" VALUE="$post_room">
<INPUT TYPE="hidden" NAME="mes" VALUE="$mes">
<INPUT TYPE="hidden" NAME="mode" VALUE="change">
<INPUT TYPE="hidden" NAME="passwd" VALUE="$passwd">
LZR[hF<INPUT NAME="new" SIZE="10" VALUE="$passwd">
<INPUT TYPE="submit" VALUE="ύX">
i<INPUT TYPE="checkbox" NAME="secure" $secure_checked
VALUE="on">uEUɃLZR[hoȂj
$cookies_help<BR>
</FORM>
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub get_contents {
	local($mes, $mon, $day, $from, $subject);
	local($min_mes, $max_mes);
	local($room, $req_mes) = @_;

	return(undef, undef, undef, undef, undef) unless ($req_mes);
	open(CONTENTS, "$FORUMPATH/$room/contents")
		|| &ErrorMsg('missing', "$room/contents");
	$_ = <CONTENTS>;
	chop;
	($min_mes, $max_mes) = /^(\d{5}) (\d{5}) \S{3,}$/;
	if (($req_mes < $min_mes) || ($req_mes >= $max_mes)) {
		close(CONTENTS);
		return(undef, undef, undef, undef, undef);
	}
	&ErrorMsg('format', "$room/contents")
		unless (($min_mes) && ($max_mes) && ($min_mes <= $max_mes));
	while (<CONTENTS>) {
		chop;
		($mes, $mon, $day, $from, $subject) = m#^(\d{5}) \d{5} \S{3,} \d{4}/(\d{2})/(\d{2}) \d{2}:\d{2}:\d{2} <(.+)> (.*)$#;
		if ($mes == $req_mes) {
			close(CONTENTS);
			return($mes, $mon, $day, $from, $subject);
		}
	}
	close(CONTENTS);
	return(undef, undef, undef, undef, undef);
}

sub email_check {
	local($user, $domain1, $domain2);
	local($email) = @_;

	($user, $domain1, $domain2) = ($email =~ /^(\S+)\@(\S+)\.(\S+)$/);
	return($user && $domain1 && $domain2);
}

sub url_check {
	local($server);
	local($url) = @_;

	($server) = ($url =~ m#^http://(\S+)$#i);
	return($server);
}

