#!/usr/local/bin/perl

$CGIPATH = '.';

#
# cancel.cgi -- make cancel form.
# Copyright (C) 1996 nir@mvg.biglobe.ne.jp
#
# This file is part of WebForum.
# WebForum is free script; you can redistribute it and/or modify it
# for any purpose.
#
# @(#)$cancel.cgi,v1.12 10 Mar 1997 nir $
#

require "$CGIPATH/forum.pl";

%http_args = &http'http_args;
$room	= $http_args{'room'};
$mes	= $http_args{'mes'};
$mode	= $http_args{'mode'};
$passwd	= $http_args{'passwd'};
$new	= substr($http_args{'new'}, 0, 8);
$secure	= $http_args{'secure'};
%http_cookie = &http'http_cookie;
$cookie_passwd = $http_cookie{'passwd'};
%gui = &forum'get_gui($http_cookie{'gui'});
$noframes = (($gui{'frame'} eq 'no') || ($http_args{'frame'} eq 'no'));
$post_option = qq(\n<INPUT TYPE="hidden" NAME="frame" VALUE="no">) if ($noframes);

$init = ($secure eq 'on');

$title = &forum'get_title($room);
&WarningMsg('Bad Forum') if ($title eq '');
&WarningMsg('Bad Article') unless ($mes);

if ($mode eq 'cancel') {
	&cancel;
} elsif ($mode eq 'change') {
	&WarningMsg('Missing Cancel Code') if ($new eq '');
	&change_pass;
} else {
	&make_cancel_form;
}

exit(0);

sub make_cancel_form {
	local($n, $min_mes, $max_mes, $match, $output);
	local($mon, $day, $from, $subject);
	local($help) = &forum'help('cancel');

	open(CONTENTS, "$FORUMPATH/$room/contents")
		|| &ErrorMsg('missing', "$room/contents");
	$_ = <CONTENTS>;
	chop;
	($min_mes, $max_mes) = /^(\d{5}) (\d{5}) \S{3,}$/;
	&ErrorMsg('format', "$room/contents")
		unless (($min_mes) && ($max_mes) && ($min_mes <= $max_mes));
	$match = 0;
	while (<CONTENTS>) {
		chop;
		($n, $mon, $day, $from, $subject) = m#^(\d{5}) \d{5} \S{3,} \d{4}/(\d{2})/(\d{2}) \d{2}:\d{2}:\d{2} <(.+)> (.*)$#;
		$match = $n, last if ($n == $mes);
	}
	close(CONTENTS);
	&WarningMsg('Bad Article') if ($match != $mes);

	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE (Cancel Article)</TITLE></HEAD>
$BODY
<H1>L̃LZ
$help</H1>
<P>${mon}${day}ɁA${from}񂪁u$titlevɏA
Lԍ $mesA薼u$subjectv̋LLZ܂B
<P>ȉ̗ɂ̋L̃LZR[hĂ
LZsĉB
<P>
<FORM ACTION="$CGIROOT/cancel.$CGI" METHOD="POST">$post_option
<INPUT TYPE="hidden" NAME="room" VALUE="$room">
<INPUT TYPE="hidden" NAME="mes" VALUE="$mes">
<INPUT TYPE="hidden" NAME="mode" VALUE="cancel">
LZR[hF<INPUT NAME="passwd" SIZE="10" VALUE="$cookie_passwd">
<INPUT TYPE="submit" VALUE="LZ">
</FORM>
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub cancel {
	local($post_body) = $BODY;
	local($output, $cancelchar, $cancelfile);

	&lock_get_contents;
	if (crypt($passwd, $cryptpass) eq $cryptpass) {
		$cancelchar = '+';
		$cancelfile = 'CancelPoster.html';
	} elsif (crypt($passwd, $syspass) eq $syspass) {
		$cancelchar = '*';
		$cancelfile = 'CancelSystem.html';
	} else {
		&WarningMsg('Bad Cancel Code');
	}
	&ErrorMsg('missing', $cancelfile) unless (-r "$FORUMPATH/$cancelfile");
	if ($forum'copy) {
		chmod(0666, "$FORUMPATH/$room/$mes.html");
		open(CANCELFILE, "$FORUMPATH/$cancelfile")
			|| &ErrorMsg('missing', "$cancelfile");
		open(MES, ">$FORUMPATH/$room/$mes.html")
			|| &ErrorMsg('write', "$room/$mes.html");
		print MES <CANCELFILE>;
		close(MES);
		close(CANCELFILE);
		chmod(0444, "$FORUMPATH/$room/$mes.html");
	} else {
		unlink("$FORUMPATH/$room/$mes.html")
			|| &ErrorMsg('unlink', "$room/$mes.html");
		symlink("../$cancelfile", "$FORUMPATH/$room/$mes.html")
			|| &ErrorMsg('link', "$room/$mes.html");
	}
	printf(CONTENTS "%05d %05d %s",
		$mes, $ref, $cancelchar x length($cryptpass));
	&forum'filelock(CONTENTS, 0);
	close(CONTENTS);

	$post_body =~ s#>$#\nonLoad="window.open('$CGIROOT/contents.$CGI?room=$room','contents')"># unless($noframes);

	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>Canceled Article</TITLE></HEAD>
$post_body
<H1>L̃LZ</H1>
${mon}${day}ɁA${from}񂪁u$titlevɏA
Lԍ $mesA薼u$subjectv̋LLZ܂B
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub change_pass {
	local($cookie, $output);

	&lock_get_contents;
	&WarningMsg('Bad Cancel Code')
		if (crypt($passwd, $cryptpass) ne $cryptpass);
	$newcryptpass = crypt($new, $cryptpass);
	&ErrorMsg('crypt', "$room/contents")
		if (length($cryptpass) != length($newcryptpass));
	printf(CONTENTS "%05d %05d %s", $mes, $ref, $newcryptpass);
	&forum'filelock(CONTENTS, 0);
	close(CONTENTS);

	$cookie = &forum'set_cookie_line('passwd', $new, $init);

	$output = "Content-Type: text/html\n$cookie\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>Cancel Code Change</TITLE></HEAD>
$BODY
<H1>LZR[hύX</H1>
${mon}${day}ɁA${from}񂪁u$titlevɏA
Lԍ $mesA薼u$subjectv
<A HREF="$FORUMROOT/$room/$mes.html">L</A>
LZR[h"<TT>$passwd</TT>""<TT>$new</TT>"ɕύX܂B
A̋LLZ鎞"<TT>$new</TT>"gĉB
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub lock_get_contents {
	local($n, $min_mes, $max_mes, $match, $tell);

	open(CONTENTS, "+<$FORUMPATH/$room/contents")
		|| &ErrorMsg('write', "$room/contents");
	&forum'filelock(CONTENTS, 1) || &ErrorMsg('lock', "$room/contents");
	$_ = <CONTENTS>;
	chop;
	($min_mes, $max_mes, $syspass) = /^(\d{5}) (\d{5}) (\S{3,})$/;
	&ErrorMsg('format', "$room/contents")
		unless (($min_mes) && ($max_mes) && ($min_mes <= $max_mes));
	$match = 0;
	while (1) {
		$tell = tell(CONTENTS);
		$_ = <CONTENTS>;
		last if (/^$/);
		chop;
		($n, $ref, $cryptpass, $mon, $day, $from, $subject) = m#^(\d{5}) (\d{5}) (\S{3,}) \d{4}/(\d{2})/(\d{2}) \d{2}:\d{2}:\d{2} <(.+)> (.*)$#;
		$match = $n, last if ($n == $mes);
	}
	&WarningMsg('Bad Article') if ($match != $mes);
	seek(CONTENTS, $tell, 0);
}

