#!/usr/local/bin/perl

$CGIPATH = '.';

#
# customize.cgi -- user customizer.
# Copyright (C) 1996 nir@mvg.biglobe.ne.jp
#
# This file is part of WebForum.
# WebForum is free script; you can redistribute it and/or modify it
# for any purpose.
#
# @(#)$customize.cgi,v1.1 4 Mar 1997 nir $
#

require "$CGIPATH/forum.pl";
require "$CGIPATH/jcode.pl";

@ids = ('name', 'email', 'url', 'passwd');

$default_customize = 'http:///customize.cgi';

%http_args = &http'http_args;
$send	= $http_args{'send'};
$set	= $http_args{'set'};
$init	= $http_args{'init'};
if (($send ne '') && $set) {
	&select_mode;
} elsif ($set) {
	&set_mode;
} else {
	&edit_mode;
}
exit(0);

sub set_mode {
	local($key);

	foreach $key (@ids) {
		$ids{$key} = $http_args{$key};
	}
	foreach $key (keys %forum'gui) {
		$gui{$key} = $http_args{$key};
	}
	foreach $key (@forum'ext_key) {
		$ext{$key} = $http_args{$key};
	}
	&http'strip_args(*ids);
	&http'strip_args(*gui);
	&http'strip_args(*ext);
	&forum'check_gui(*gui);
	&kanji_convert;
	&ssi_check;
	$name = $ids{'name'};
	$email = $ids{'email'};
	$url = $ids{'url'};
	$passwd = $ids{'passwd'};
	$gui = &http'make_http_args(%gui);
	$ext = &http'make_http_args(%ext);
	&quote_items;
	&set_items;
}

sub edit_mode {
	local($key);

	%http_cookie = &http'http_cookie;
	foreach $key (@ids) {
		$ids{$key} = $http_cookie{$key};
	}
	&http'strip_args(*ids);
	%gui = &forum'get_gui($http_cookie{'gui'});
	%ext = &forum'get_ext($http_cookie{'ext'});
	&kanji_convert;
	&quote_items;
	&edit_items;
}

sub quote_items {
	local($key);

	foreach $key (keys %ids) {
		$ids{$key} = &http'http_quote($ids{$key});
	}
	foreach $key (keys %gui) {
		$gui{$key} = &http'http_quote($gui{$key});
	}
	foreach $key (keys %ext) {
		$ext{$key} = &http'http_quote($ext{$key});
	}
}

sub kanji_convert {
	local($opt) = ($forum'htoz) ? 'z' : '';

	$ids{'name'} = &jcode'to('sjis', $ids{'name'}, '', $opt);
	$gui{'oldfmt'} = &jcode'to('sjis', $gui{'oldfmt'}, '', $opt);
	$gui{'newfmt'} = &jcode'to('sjis', $gui{'newfmt'}, '', $opt);
	$gui{'listfmt'} = &jcode'to('sjis', $gui{'listfmt'}, '', $opt);
}

sub ssi_check {
	$gui{'oldfmt'} = &forum'ssi_commentout($gui{'oldfmt'});
	$gui{'newfmt'} = &forum'ssi_commentout($gui{'newfmt'});
	$gui{'listfmt'} = &forum'ssi_commentout($gui{'listfmt'});
}

sub edit_items {
	local($other_site, $output, $submit);
	local($help) = &forum'help('customize');
	local($frame_rowcol) = ($gui{'frame'} eq 'rowcol') ? 'CHECKED' : '';
	local($frame_colrow) = ($gui{'frame'} eq 'colrow') ? 'CHECKED' : '';
	local($frame_no) = ($gui{'frame'} eq 'no') ? 'CHECKED' : '';
	local($sort_order) = ($gui{'sort'} eq 'order') ? 'CHECKED' : '';
	local($sort_reverse) = ($gui{'sort'} eq 'reverse') ? 'CHECKED' : '';
	local($sort_mix) = ($gui{'sort'} eq 'mix') ? 'CHECKED' : '';
	local($suppress_on) = ($gui{'suppress'} eq 'on') ? 'CHECKED' : '';
	local($suppress_off) = ($gui{'suppress'} ne 'on') ? 'CHECKED' : '';
	local($menu_extensions) = &list_extensions('menu');
	local($contents_extensions) = &list_extensions('contents');
	local($icon_extensions) = &list_extensions('icon');

	if (($send eq '') || ($send eq $default_customize)) {
		$other_site = qq(ł̃JX^}CY<A HREF="$CGIROOT/customize.$CGI?send=1&set=1">̂ԉcɑ</A>o܂);
		$send = "$CGIROOT/customize.$CGI";
		$submit = 'XV';
	} else {
		$other_site = qq(ł̃JX^}CY "$send" ɑ܂);
		$submit = '';
	}

	$output = sprintf("Content-Type: text/html\n%s\n%s\n\n",
		&forum'last_modified(time),
		&forum'expires(time));
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE (User Customizer)</TITLE></HEAD>
$BODY
<H1>[UJX^}CY
$help</H1>

$other_site
<FORM ACTION="$send" METHOD="POST">

<H2>l</H2>
<INPUT TYPE="hidden" NAME="set" VALUE="on">
O<BR>
<INPUT NAME="name" SIZE="30" VALUE="$ids{'name'}"><BR>
dqCAhX<BR>
<INPUT NAME="email" SIZE="60" VALUE="$ids{'email'}"><BR>
Home Page URL<BR>
<INPUT NAME="url" SIZE="60" VALUE="$ids{'url'}"><BR>
LZR[h<BR>
<INPUT NAME="passwd" SIZE="30" VALUE="$ids{'passwd'}">
<HR>

<H2></H2>
t[A
<INPUT TYPE="radio" NAME="frame"
$frame_rowcol VALUE="rowcol">cĂ牡A
<INPUT TYPE="radio" NAME="frame"
$frame_colrow VALUE="colrow">ĂcA
<INPUT TYPE="radio" NAME="frame"
$frame_no VALUE="no">gȂ<BR>
c䗦 = <INPUT NAME="row1" SIZE="5" VALUE="$gui{'row1'}">
: <INPUT NAME="row2" SIZE="5" VALUE="$gui{'row2'}"><BR>
䗦 = <INPUT NAME="col1" SIZE="5" VALUE="$gui{'col1'}">
: <INPUT NAME="col2" SIZE="5" VALUE="$gui{'col2'}"><BR>
Ǔt <INPUT NAME="oldfmt" SIZE="60" VALUE="$gui{'oldfmt'}"><BR>
Ǔt <INPUT NAME="newfmt" SIZE="60" VALUE="$gui{'newfmt'}"><BR>
<FONT SIZE="-1">(%Y=NA%y=N(2)A%m=A%d=A%H=A%M=A%S=b)A(%%=%)</FONT><BR>
ꗗ\\ <INPUT NAME="listfmt" SIZE="60" VALUE="$gui{'listfmt'}"><BR>
<FONT SIZE="-1">(%N,%n=LԍA%R,%r=QƔԍ)(͍ŏ0})A<BR>
(%Y=NA%y=N(2)A%m=A%d=A%H=A%M=A%S=b)A<BR>
(%I=CfgA%i=ACRA%f=OA%s=\\)A(%%=%)</FONT><BR>
LźA
<INPUT TYPE="radio" NAME="sort" $sort_order VALUE="order">A
<INPUT TYPE="radio" NAME="sort" $sort_reverse VALUE="reverse">tA
<INPUT TYPE="radio" NAME="sort" $sort_mix VALUE="mix">Xbh͐AXbhԂ͋t<BR>
1y[a̋L <INPUT NAME="articles" SIZE="5" VALUE="$gui{'articles'}"> 
d <INPUT NAME="overlap" SIZE="5" VALUE="$gui{'overlap'}"><BR>
Cfg̐[E <INPUT NAME="indent" SIZE="5" VALUE="$gui{'indent'}"><BR>
LZLA
<INPUT TYPE="radio" NAME="suppress" $suppress_off VALUE="off">\\A
<INPUT TYPE="radio" NAME="suppress" $suppress_on VALUE="on">\\Ȃ<BR>
<HR>

<H2>g@\\gݍ</H2>

<H3>Iʊg@\\</H3>
$menu_extensions
<H3>ꗗʊg@\\ (s[h)</H3>
$contents_extensions
<H3>ꗗʊg@\\ (ACR[h)</H3>
$icon_extensions<HR>

<INPUT TYPE="submit" VALUE="$submit">
<INPUT TYPE="submit" NAME="init" VALUE="lɖ߂">
<INPUT TYPE="reset" VALUE="Zbg">
</FORM>
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}

sub list_extensions {
	local($i, $key, $checked, $extensions);
	local($class) = @_;

	foreach $key (@forum'ext_key) {
		next if ($forum'ext_class{$key} ne $class);
		$checked = ($ext{$key} eq 'on') ? 'CHECKED' : '';
		$extensions .= qq/<INPUT TYPE="checkbox" NAME="$key"\n$checked VALUE="on">$forum'ext_name{$key} ($forum'ext_comment{$key})<BR>\n/;
	}
	return($extensions);
}

sub set_items {
	local($key, $cookie, $output);
	local($help) = &forum'help('customize');

	$cookie = &forum'set_cookie_line('name', $name, $init);
	$cookie .= &forum'set_cookie_line('email', $email, $init);
	$cookie .= &forum'set_cookie_line('url', $url, $init);
	$cookie .= &forum'set_cookie_line('passwd', $passwd, $init);
	$cookie .= &forum'set_cookie_line('gui', $gui, $init);
	$cookie .= &forum'set_cookie_line('ext', $ext, $init);

	$output = sprintf("Content-Type: text/html\n%s\n%s\n%s\n",
		&forum'last_modified(time),
		&forum'expires(time),
		$cookie);
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE (User Customizer Output)</TITLE></HEAD>
$BODY
<H1>[UJX^}CYo^
$help</H1>
EOL

	if ($init) {
		$output .= "[UJX^}CY͏܂\n";
	} else {
		$output .= "ȉ̍ڂ HTTP Cookies ɃZbg܂\n";
		$output .= "<H2>l</H2>\n<DL>\n";
		foreach $key (sort (keys %ids)) {
			$output .= "<DT>$key = '$ids{$key}'\n";
		}
		$output .= "</DL>\n\n";
		$output .= "<H2></H2>\n<DL>\n";
		foreach $key (sort (keys %gui)) {
			$output .= "<DT>$key = '$gui{$key}'\n";
		}
		$output .= "</DL>\n\n";
		$output .= "<H2>g@\\gݍ</H2>\n<DL>\n";
		foreach $key (sort (keys %ext)) {
			$output .= "<DT>$key = '$ext{$key}'\n";
		}
		$output .= "</DL>\n\n";
	}
        $output .= "$FOOTER\n</BODY>\n</HTML>\n";
	&forum'convert_print(*output);
}

sub select_mode {
	local($output);
	local($help) = &forum'help('customize');

	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE (User Customizer: Select Forum)</TITLE></HEAD>
$BODY
<H1>[UJX^}CYw
$help</H1>

<FORM ACTION="$CGIROOT/customize.$CGI" METHOD="POST">

JX^}CYuԉcv́u[UJX^}CYvyGaURL<BR>
<INPUT NAME="send" SIZE="80" VALUE="$default_customize"><BR>

<INPUT TYPE="submit" VALUE="w肷">
<INPUT TYPE="reset" VALUE="Zbg">
</FORM>
$FOOTER
</BODY>
</HTML>
EOL
	&forum'convert_print(*output);
}
