#
# forum.pl -- common definitions and functions of WebForum.
# Copyright (C) 1996-1998 nir@mvg.biglobe.ne.jp
#
# This file is part of WebForum.
# WebForum is free script; you can redistribute it and/or modify it
# for any purpose.
#
# @(#)$Id: forum.pl,v 1.18.1.3 1998/12/19 06:01:19 nir Exp $
#

require "$CGIPATH/site.pl";
require "$CGIPATH/http.pl";
require "timelocal.pl";

package forum;

binmode(STDOUT);

$ENV{'SERVER_NAME'} = $server_name if ($server_name ne '');
&tz_adjust;

$forumtitle = 'WebForum' if ($forumtitle eq '');
$main'FORUMTITLE = $forumtitle;
$forumroot = '.' if ($forumroot eq '');
$main'FORUMROOT = $forumroot;
$forumpath = '.' if ($forumpath eq '');
$main'FORUMPATH = $forumpath;
$cgiroot = $forumroot if ($cgiroot eq '');
$main'CGIROOT = $cgiroot;
$perl_cgi = 'cgi' if ($perl_cgi eq '');
$main'CGI = $perl_cgi;
$body = '<BODY BGCOLOR="#FFFFFF">' if ($body eq '');
$main'BODY = $body;
$main'OWNER = $owner;

$main'TEXTICON = qq{<IMG SRC="$forumroot/icons/text.gif" ALT="*"
BORDER="0" WIDTH="20" HEIGHT="20">};
$main'NEWTEXTICON = qq{<IMG SRC="$forumroot/icons/newtext.gif" ALT="!"
BORDER="0" WIDTH="20" HEIGHT="20">};
$main'NEWICON = qq{<IMG SRC="$forumroot/icons/new.gif" ALT=""
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'FOLLOWICON = qq{<IMG SRC="$forumroot/icons/follow.gif" ALT=""
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'CANCELICON = qq{<IMG SRC="$forumroot/icons/cancel.gif" ALT=""
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'MENUICON = qq{<IMG SRC="$forumroot/icons/menu.gif" ALT=""
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'TOPICON = qq{<IMG SRC="$forumroot/icons/top.gif" ALT="[TOP]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'BOTICON = qq{<IMG SRC="$forumroot/icons/bot.gif" ALT="[BOT]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'PREVICON = qq{<IMG SRC="$forumroot/icons/prev.gif" ALT="[PREV]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'NEXTICON = qq{<IMG SRC="$forumroot/icons/next.gif" ALT="[NEXT]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'WIDEICON = qq{<IMG SRC="$forumroot/icons/wide.gif" ALT="[WIDE]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'DATEICON = qq{<IMG SRC="$forumroot/icons/date.gif" ALT="[DATE MODE]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'THREADICON = qq{<IMG SRC="$forumroot/icons/thread.gif" ALT="[THREAD MODE]"
ALIGN="top" BORDER="0" WIDTH="20" HEIGHT="20">};
$main'HELPICON = qq{<IMG SRC="$forumroot/icons/help.gif" ALT="[HELP]"
BORDER="0" WIDTH="20" HEIGHT="20">};

&room_init;
&gui_init;
&ext_init;
$footer = &footer_init;
$main'FOOTER = $footer;
$cookie_expires = time + 365 * 24 * 60 * 60;
srand;

@saltset = ('.', '/', '0' .. '9', 'A' .. 'Z', 'a' .. 'z');

%reason = (
	'missing',	't@C܂',
	'write',	't@Cɏ߂܂',
	'link',		't@CNł܂',
	'unlink',	't@CANł܂',
	'format',	't@C̏sł',
	'lock',		'bNo܂',
	'crypt',	'ÍR[h̒ς܂',
	'',		'`G[ł',
);

$want_reply = <<"EOL";
萔łAG[NƂ̏󋵂
<A HREF="mailto:$owner">VXeǗ</A>
($owner) ܂ŁAm点ƍKłB
EOL

sub main'ErrorMsg {
	local($output);
	local($help) = &help('error');
	local($reason, $path) = @_;

	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>System Error!!</TITLE></HEAD>
$body
<H1>System Error!!
$help</H1>
VXeɒvIG[܂B
 ('$reason{$reason}', "$path")<BR>
<P>
$want_reply
$footer
</BODY>
</HTML>
EOL
	&convert_print(*output);

	exit(0);
}

sub main'WarningMsg {
	local($output);
	local($help) = &help('error');
	local($reason) = @_;

	$output = "Content-Type: text/html\n\n";
	$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$reason</TITLE></HEAD>
$body
<H1>$reason
$help</H1>
EOL

	$_ = $reason;
	BODY: {
		/^Bad Article/ && do {$output .= <<"EOL"; last BODY;};
Lԍ̌łB
<P>
A URL Lq̂ȂA
p[^ĊmFĉB
Nǂ̂ȂA
$want_reply
EOL
		/^Bad Cancel Code/ && do {$output .= <<"EOL"; last BODY;};
LZR[ȟłB
x͂LZR[hmFĉB
<P>
LZR[hYĂ܂ǁA
ǂĂLLZƂɂ́A
<A HREF="mailto:$owner">VXeǗ</A>
($owner) Ƀ[oĉB
EOL
		/^Bad Email Address/ && do {$output .= <<"EOL"; last BODY;};
dq[AhX͂Ă܂B
<P>
\\󂠂܂񂪁Adq[AhX͕̓͂K{ƂȂĂ܂B
p\\RʐMgĂ[AhX Internet 烁[͂
name\@domain `gĉB
Ⴆ NiftyServe Ȃ <TT>ABC12345\@niftyserve.or.jp</TT> łB
EOL
		/^Bad Forum/ && do {$output .= <<"EOL"; last BODY;};
tH[̌łB
<P>
A URL Lq̂ȂA
p[^ĊmFĉB
Nǂ̂ȂA
$want_reply
EOL
		/^Missing Cancel Code/ && do {$output .= <<"EOL"; last BODY;};
LZR[h͂Ă܂B
EOL
		/^Missing Name/ && do {$output .= <<"EOL"; last BODY;};
O͂Ă܂B
<P>
\\󂠂܂񂪁AO͕̓͂K{ƂȂĂ܂B
O͖{łKv͖yl[ł܂܂񂪁A
K͂ĉB
EOL
		/^Missing Subject/ && do {$output .= <<"EOL"; last BODY;};
薼͂Ă܂B
<P>
\\󂠂܂񂪁A薼͕̓͂K{ƂȂĂ܂B
L̓eȒPɕ\\킷lȑ薼tĉB
EOL
		/^Missing Text/ && do {$output .= <<"EOL"; last BODY;};
{͂Ă܂B
<P>
ꂪĂ͂傤ȂłˁB<TT>(^^;;</TT>
EOL
		/^Read Only/ && do {$output .= <<"EOL"; last BODY;};
Read Only cłB
<P>
̉c͓ǂݍ݂̂݉\\œeo܂B
̉cIŉB
EOL
		$output .= <<"EOL";
߂ȂB`G[ɂȂ܂B<TT>(^^;;</TT>
<P>
$want_reply
EOL
	}
	$output .= <<"EOL";
$footer
</BODY>
</HTML>
EOL
	&convert_print(*output);

	exit(0);
}

sub room_init {
	local($i, $key);

	for ($i = 0; $i <= $#room; $i += 4) {
		$key = $room[$i];
		push(@room_key, $key);
		$room_title{$key} = $room[$i + 1];
		$room_max{$key} = $room[$i + 2];
		$room_forward{$key} = $room[$i + 3];
	}
}

sub gui_init {
	if (!defined($gui{'frame'})) {
		$gui{'frame'} = 'rowcol';
	}
	if (($gui{'row1'} eq '') || ($gui{'row2'} eq '')) {
		($gui{'row1'}, $gui{'row2'}) = ('25%', '75%');
	}
	if (($gui{'col1'} eq '') || ($gui{'col2'} eq '')) {
		($gui{'col1'}, $gui{'col2'}) = ('35%', '65%');
	}
	if (!defined($gui{'oldfmt'})) {
		$gui{'oldfmt'} = '(%m/%d)';
	}
	if (!defined($gui{'newfmt'})) {
		$gui{'newfmt'} = '<EM>(%m/%d)</EM>';
	}
	if ($gui{'listfmt'} eq '') {
		$gui{'listfmt'} = '%I%i%m/%d[%f]%s';
	}
	if (!defined($gui{'sort'})) {
		$gui{'sort'} = 'order';
	}
	if (!defined($gui{'articles'})) {
		$gui{'articles'} = '30';
	}
	if (!defined($gui{'overlap'})) {
		$gui{'overlap'} = '5';
	}
	if (!defined($gui{'indent'})) {
		$gui{'indent'} = '5';
	}
	if (!defined($gui{'suppress'})) {
		$gui{'suppress'} = 'off';
	}
}

sub ext_init {
	local($i, $key);

	for ($i = 0; $i <= $#ext; $i += 7) {
		$key = $ext[$i];
		push(@ext_key, $key);
		$ext_name{$key} = $ext[$i + 1];
		$ext_class{$key} = $ext[$i + 2];
		$ext_target{$key} = $ext[$i + 3];
		$ext_cmds{$key} = $ext[$i + 4];
		$ext_comment{$key} = $ext[$i + 5];
		$ext{$key} = $ext[$i + 6];
	}
}

sub footer_init {
	local($mday, $mon, $year) = (&http'local_time((stat($0))[9]))[3, 4, 5];

	sprintf("%s<HR>\n<ADDRESS>%s</ADDRESS>\n<EM>Last Update: %d %s %d</EM>",
		$foot, $owner, $mday, $http'month[$mon], $year + 1900);
}

sub line_in_convert {
	local(*_) = @_;

	s/\r\n?/\n/g;
}

sub line_out_convert {
	local(*_) = @_;

	s/\r\n?/\n/g;
	s/\n/\r\n/g;
}

sub convert_print {
	local(*_) = @_;

	&line_out_convert(*_);
	print;
}

sub get_rooms {
	return(@room_key);
}

sub get_title {
	$room_title{$_[0]};
}

sub get_passwd {
	sprintf("%s%05d",
		pack("CCC",
			65 + int(rand(26)),
			65 + int(rand(26)),
			65 + int(rand(26))),
		int(rand(100000)));
}

sub get_cryptpass {
	local($cryptpass, $salt);
	local($passwd) = @_;

	$salt = $saltset[int(rand(64))] . $saltset[int(rand(64))];
	$cryptpass = crypt($passwd, $salt);
	return($cryptpass);
}

sub tz_adjust {
	local($org_min, $server_min, $local_min);
	local($y, $h, $m);

	($y, $h, $m) = (localtime(0))[5, 2, 1];
	$h -= 24 if ($y < 70);
	$org_min = 60 * $h + $m;
	if (($h, $m) = $server_tz =~ /^([+-]?\d\d)(\d\d)$/) {
		$server_min = 60 * $h + $m;
		$http'server_adj = ($server_min - $org_min) * 60;
	} else {
		$server_min = $org_min;
	}
	if (($h, $m) = $local_tz =~ /^([+-]?\d\d)(\d\d)$/) {
		$local_min = 60 * $h + $m;
		$http'local_adj = ($local_min - $server_min) * 60;
	}
}

sub last_modified {
	sprintf("Last-Modified: %s", &http'http_date($_[0]));
}

sub expires {
	sprintf("Expires: %s", &http'http_date($_[0]));
}

sub set_cookie_line {
        local($time);
	local($path) = $cgiroot;
        local($name, $value, $init) = @_;

        return('') if ($name eq '');
        $time = $cookie_expires;
        $time = time if (($value eq '') || ($init));
	$path =~ s#^http://?[^/]+/#/#i;
        &http'set_cookie($name, $value, $time, "$path/") . "\n";
}

sub if_modified_since {
	local($sec, $min, $hour, $mday, $mon, $year, $wday, $smon, $swday);

	$_ = $ENV{'HTTP_IF_MODIFIED_SINCE'};
	($swday, $mday, $smon, $year, $hour, $min, $sec) =
		/^(\w+), (\d+) (\w+) (\d+) (\d+):(\d+):(\d+)/;
	($swday, $mday, $smon, $year, $hour, $min, $sec) =
		/^(\w+), (\d+)-(\w+)-(\d+) (\d+):(\d+):(\d+)/ if ($sec eq '');
	($swday, $smon, $mday, $hour, $min, $sec, $year) =
		/^(\w+) (\w+) (\d+) (\d+):(\d+):(\d+) (\d+)/ if ($sec eq '');
	$mon = &montoi($smon);
	$wday = &wdaytoi($swday);
	$year -= 1900 if ($year >= 1900);
	return(-1) if (($sec eq '') || ($mon eq '') || ($wday eq ''));
	return(-1) unless (&datetime_check($sec, $min, $hour, $mday, $mon, $year));
	&main'timegm($sec, $min, $hour, $mday, $mon, $year) + $http'server_adj;
}

sub get_room_menu {
	local($output, $room, $mtime, $last_modified, $format);
	local($if_modified_since) = &if_modified_since;
	local($prefix, *gui) = @_;
	local($noframes) = ($gui{'frame'} eq 'no');
	local($oldfmt) = &escape_format($gui{'oldfmt'});
	local($newfmt) = &escape_format($gui{'newfmt'});

	foreach $room (@room_key) {
		$mtime = (stat("$forumpath/$room/contents"))[9];
		$last_modified = $mtime if ($mtime > $last_modified);
		$format = (($if_modified_since >= 0) && ($mtime > $if_modified_since)) ? $newfmt : $oldfmt;
		$output .= qq{$prefix<A HREF="$cgiroot/contents.$perl_cgi?room=$room};
		$output .= ($noframes) ? qq{&frame=no"} : qq{" TARGET="contents"\nonClick="window.open('$forumroot/$room/','article')"};
		$output .= qq(>$room_title{$room}</A>\n);
		$output .= &eval_var($format, 'YymdHMS', $mtime);
		$output .= "\n";
	}
	return($output, $last_modified);
}

sub eval_var {
	local(%var);
	local($Y, $y, $m, $d, $H, $M, $S, $n, $r);
	local($_, $varstr, $mtime, $N, $R, $I, $i, $f, $s, $T) = @_;

	($S, $M, $H, $d, $m, $Y) = (&http'local_time($mtime))[0..5];
	$var{'S'} = sprintf("%02d", $S);
	$var{'M'} = sprintf("%02d", $M);
	$var{'H'} = sprintf("%02d", $H);
	$var{'d'} = sprintf("%02d", $d);
	$var{'m'} = sprintf("%02d", $m + 1);
	$var{'Y'} = sprintf("%04d", $Y + 1900);
	$var{'y'} = substr($var{'Y'}, 2);
	$var{'N'} = sprintf("%05d", $N);
	$var{'n'} = $N + 0;
	$var{'R'} = sprintf("%05d", $R);
	$var{'r'} = $R + 0;
	$var{'I'} = $I;
	$var{'i'} = $i;
	$var{'f'} = $f;
	$var{'s'} = $s;
	$var{'T'} = $T;
	$var{'%'} = '%';
	s/%([${varstr}%])/$var{$1}/g;
	return($_);
}

sub datetime_check {
	local($sec, $min, $hour, $mday, $mon, $year) = @_;

	if (($sec < 0) || ($sec >= 60)
	 || ($min < 0) || ($min >= 60)
	 || ($hour < 0) || ($hour >= 24)
	 || ($mday < 1) || ($mday > 31)
	 || ($mon < 0) || ($mon >= 12)
	 || ($year < 0)) {
		return(0);
	}
	return(1);
}

sub montoi {
	local($mon);
	local($smon) = @_;

	for ($mon = 0; $mon < 12; $mon++) {
		return($mon) if ($http'mon[$mon] eq $smon);
	}
	for ($mon = 0; $mon < 12; $mon++) {
		return($mon) if ($http'month[$mon] eq $smon);
	}
	return('');
}

sub wdaytoi {
	local($wday);
	local($swday) = @_;

	for ($wday = 0; $wday < 7; $wday++) {
		return($wday) if ($http'wday[$wday] eq $swday);
	}
	for ($wday = 0; $wday < 7; $wday++) {
		return($wday) if ($http'weekday[$wday] eq $swday);
	}
	return('');
}

sub make_extensions {
	package main;
	local($key, $extensions, $target_frame);
	local($class, $prefix, $delimiter, $noframes, *args) = @_;

	foreach $key (@forum'ext_key) {
		next if ($forum'ext_class{$key} ne $class);
		next if ($args{$key} ne 'on');
		$ext_cmds = eval(qq("$forum'ext_cmds{$key}"));
		$target_frame = ($noframes) ? '' : qq(\nTARGET="$forum'ext_target{$key}");
		$extensions .= qq($prefix<A HREF="$CGIROOT/$ext_cmds"$target_frame>$forum'ext_name{$key}</A>$delimiter);
	}
	return($extensions);
}

sub get_ext {
	local($key);
	local(%new);
	local($ext) = @_;
	local(%args) = &http'conv_http_args($ext);

	&http'strip_args(*args);
	foreach $key (@ext_key) {
		$new{$key} = (defined($args{$key})) ? $args{$key} : $ext{$key};
	}
	return(%new);
}

sub get_gui {
	local($gui) = @_;
	local(%args) = &http'conv_http_args($gui);

	&http'strip_args(*args);
	&check_gui(*args);
	&retrieve_gui(*args);
	return(%args);
}

sub check_gui {
	local(*args) = @_;

	if (!($args{'frame'} =~ /^(rowcol|colrow|no)$/)) {
		delete $args{'frame'};
	}
	if (($args{'row1'} eq '')
	 || ($args{'row2'} eq '')) {
		delete $args{'row1'};
		delete $args{'row2'};
	}
	if (($args{'col1'} eq '')
	 || ($args{'col2'} eq '')) {
		delete $args{'col1'};
		delete $args{'col2'};
	}
	if ($args{'listfmt'} eq '') {
		delete $args{'listfmt'};
	}
	if (!($args{'sort'} =~ /^(order|reverse|mix)$/)) {
		delete $args{'sort'};
	}
	if (!($args{'articles'} =~ /^\d+$/)) {
		delete $args{'articles'};
	}
	if (!($args{'overlap'} =~ /^\d+$/)) {
		delete $args{'overlap'};
	}
	if ($args{'indent'} <= 0) {
		delete $args{'indent'};
	}
	if ($args{'indent'} > 20) {
		$args{'indent'} = 20;
	}
}

sub retrieve_gui {
	local($key);
	local(*args) = @_;

	foreach $key (keys %gui) {
		$args{$key} = $gui{$key} unless (defined($args{$key}));
	}
}

sub escape_format {
	local($_) = @_;

	s/\\\\/\\134/g;
	s/\\a/\a/g;
	s/\\n/\n/g;
	s/\\r/\r/g;
	s/\\t/\t/g;
	s/\\f/\f/g;
	s/\\e/\e/g;
	s/\\(\d{2,3})/pack('C',oct($1))/eg;
	s/\\x([a-f0-9]{2})/pack('C',hex($1))/ieg;
	return(&ssi_commentout($_));
}

sub ssi_commentout {
	local($_) = @_;

	if (/<!\s*--\s*#/) {
		s/<!\s*--/&lt;!--/g;
		s/--\s*>/--&gt;/g;
	}
	return($_);
}

sub help {
	local($help_link);
	local($term) = @_;

	$help_link = $help{$term};
	$help_link = $help{''} if ($help_link eq '');
	return('') if ($help_link eq '');
	return(sprintf(qq{<A HREF="$help_link"\n}, $term)
		     . qq{TARGET="help">$main'HELPICON</A>});
}

sub filelock {
	local($n);
	local($package) = caller;
	local($fh, $lock) = @_;

	return(1) if ($flock_disable);
	return(0) if ($fh eq '');
	$fh =~ s/^[^']+$/$package'$&/;
	if ($lock) {
		return(1) if (flock($fh, 6));
		for ($n = 0; $n < 60; $n++) {
			sleep(1);
			return(1) if (flock($fh, 6));
		}
		return(0);
	} else {
		flock($fh, 8);
	}
}

1;
